package com.goafanti.common.enums;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

public enum IntellectualPropertyType {
	
	COMMON(0, "非系统申请知识产权"),
	PATENT(1, "专利类型知识产权"),
	COPYRIGHT(2, "软著类型知识产权"),
	OTHER(3, "其他");

	private IntellectualPropertyType(Integer code, String desc) {
		this.code = code;
		this.desc = desc;
	}

	private static Map<Integer, IntellectualPropertyType> status = new HashMap<Integer, IntellectualPropertyType>();

	static {
		for (IntellectualPropertyType value : IntellectualPropertyType.values()) {
			status.put(value.getCode(), value);
		}
	}

	public static IntellectualPropertyType getStatus(Integer code) {
		if (containsType(code)) {
			return status.get(code);
		}
		return OTHER;
	}

	public static IntellectualPropertyType getStatus(String code) {
		if (StringUtils.isNumeric(code)) {
			return getStatus(Integer.parseInt(code));
		}
		return OTHER;
	}

	public static boolean containsType(Integer code) {
		return status.containsKey(code);
	}

	private Integer	code;
	private String	desc;

	public Integer getCode() {
		return code;
	}

	public String getDesc() {
		return desc;
	}

}
